import Conductor from 'conductor-node';
const conductor = new Conductor({
apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted
});
const journalEntry = await conductor.qbd.journalEntries.create({
transactionDate: '2024-10-01',
conductorEndUserId: 'end_usr_1234567abcdefg',
});
console.log(journalEntry.id);import os
from datetime import date
from conductor import Conductor
conductor = Conductor(
api_key=os.environ.get("CONDUCTOR_SECRET_KEY"), # This is the default and can be omitted
)
journal_entry = conductor.qbd.journal_entries.create(
transaction_date=date.fromisoformat("2024-10-01"),
conductor_end_user_id="end_usr_1234567abcdefg",
)
print(journal_entry.id)curl --request POST \
--url https://api.conductor.is/v1/quickbooks-desktop/journal-entries \
--header 'Authorization: Bearer <token>' \
--header 'Conductor-End-User-Id: <conductor-end-user-id>' \
--header 'Content-Type: application/json' \
--data '
{
"transactionDate": "2024-10-01",
"refNumber": "JE-1234",
"isAdjustment": false,
"isHomeCurrencyAdjustment": false,
"areAmountsEnteredInHomeCurrency": false,
"currencyId": "80000001-1234567890",
"exchangeRate": 1.2345,
"externalId": "12345678-abcd-1234-abcd-1234567890ab",
"debitLines": [
{
"accountId": "80000001-1234567890",
"amount": "1000.00",
"memo": "Monthly utility bill settlement",
"entityId": "80000001-1234567890",
"classId": "80000001-1234567890",
"salesTaxItemId": "80000001-1234567890",
"billingStatus": "billable"
}
],
"creditLines": [
{
"accountId": "80000001-1234567890",
"amount": "1000.00",
"memo": "Allocated funds for office lease payment",
"entityId": "80000001-1234567890",
"classId": "80000001-1234567890",
"salesTaxItemId": "80000001-1234567890",
"billingStatus": "billable"
}
]
}
'<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.conductor.is/v1/quickbooks-desktop/journal-entries",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'transactionDate' => '2024-10-01',
'refNumber' => 'JE-1234',
'isAdjustment' => false,
'isHomeCurrencyAdjustment' => false,
'areAmountsEnteredInHomeCurrency' => false,
'currencyId' => '80000001-1234567890',
'exchangeRate' => 1.2345,
'externalId' => '12345678-abcd-1234-abcd-1234567890ab',
'debitLines' => [
[
'accountId' => '80000001-1234567890',
'amount' => '1000.00',
'memo' => 'Monthly utility bill settlement',
'entityId' => '80000001-1234567890',
'classId' => '80000001-1234567890',
'salesTaxItemId' => '80000001-1234567890',
'billingStatus' => 'billable'
]
],
'creditLines' => [
[
'accountId' => '80000001-1234567890',
'amount' => '1000.00',
'memo' => 'Allocated funds for office lease payment',
'entityId' => '80000001-1234567890',
'classId' => '80000001-1234567890',
'salesTaxItemId' => '80000001-1234567890',
'billingStatus' => 'billable'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Conductor-End-User-Id: <conductor-end-user-id>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.conductor.is/v1/quickbooks-desktop/journal-entries"
payload := strings.NewReader("{\n \"transactionDate\": \"2024-10-01\",\n \"refNumber\": \"JE-1234\",\n \"isAdjustment\": false,\n \"isHomeCurrencyAdjustment\": false,\n \"areAmountsEnteredInHomeCurrency\": false,\n \"currencyId\": \"80000001-1234567890\",\n \"exchangeRate\": 1.2345,\n \"externalId\": \"12345678-abcd-1234-abcd-1234567890ab\",\n \"debitLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Monthly utility bill settlement\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ],\n \"creditLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Allocated funds for office lease payment\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Conductor-End-User-Id", "<conductor-end-user-id>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.conductor.is/v1/quickbooks-desktop/journal-entries")
.header("Conductor-End-User-Id", "<conductor-end-user-id>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"transactionDate\": \"2024-10-01\",\n \"refNumber\": \"JE-1234\",\n \"isAdjustment\": false,\n \"isHomeCurrencyAdjustment\": false,\n \"areAmountsEnteredInHomeCurrency\": false,\n \"currencyId\": \"80000001-1234567890\",\n \"exchangeRate\": 1.2345,\n \"externalId\": \"12345678-abcd-1234-abcd-1234567890ab\",\n \"debitLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Monthly utility bill settlement\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ],\n \"creditLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Allocated funds for office lease payment\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.conductor.is/v1/quickbooks-desktop/journal-entries")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Conductor-End-User-Id"] = '<conductor-end-user-id>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"transactionDate\": \"2024-10-01\",\n \"refNumber\": \"JE-1234\",\n \"isAdjustment\": false,\n \"isHomeCurrencyAdjustment\": false,\n \"areAmountsEnteredInHomeCurrency\": false,\n \"currencyId\": \"80000001-1234567890\",\n \"exchangeRate\": 1.2345,\n \"externalId\": \"12345678-abcd-1234-abcd-1234567890ab\",\n \"debitLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Monthly utility bill settlement\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ],\n \"creditLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Allocated funds for office lease payment\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"id": "123ABC-1234567890",
"objectType": "qbd_journal_entry",
"createdAt": "2025-01-01T12:34:56.000Z",
"updatedAt": "2025-02-01T12:34:56.000Z",
"revisionNumber": "1721172183",
"transactionDate": "2024-10-01",
"refNumber": "JE-1234",
"isAdjustment": false,
"isHomeCurrencyAdjustment": false,
"areAmountsEnteredInHomeCurrency": false,
"currency": {
"id": "80000001-1234567890",
"fullName": "USD"
},
"exchangeRate": 1.2345,
"externalId": "12345678-abcd-1234-abcd-1234567890ab",
"debitLines": [
{
"id": "456DEF-1234567890",
"objectType": "qbd_journal_debit_line",
"account": {
"id": "80000001-1234567890",
"fullName": "Checking"
},
"amount": "1000.00",
"memo": "Monthly utility bill settlement",
"entity": {
"id": "80000001-1234567890",
"fullName": "Acme Corporation"
},
"class": {
"id": "80000001-1234567890",
"fullName": "Facilities & Utilities"
},
"salesTaxItem": {
"id": "80000001-1234567890",
"fullName": "State Sales Tax"
},
"billingStatus": "billable"
}
],
"creditLines": [
{
"id": "456DEF-1234567890",
"objectType": "qbd_journal_credit_line",
"account": {
"id": "80000001-1234567890",
"fullName": "Accounts-Payable"
},
"amount": "1000.00",
"memo": "Allocated funds for office lease payment",
"entity": {
"id": "80000001-1234567890",
"fullName": "Acme Corporation"
},
"class": {
"id": "80000001-1234567890",
"fullName": "Administrative"
},
"salesTaxItem": {
"id": "80000001-1234567890",
"fullName": "State Sales Tax"
},
"billingStatus": "billable"
}
],
"customFields": [
{
"ownerId": "0",
"name": "Customer Rating",
"type": "string_1024_type",
"value": "Premium"
}
]
}Create a journal entry
Creates a journal entry with balanced debit and credit lines. QuickBooks Desktop requires total debits to equal total credits, and any line that posts to Accounts Receivable or Accounts Payable must include the related customer or vendor reference.
import Conductor from 'conductor-node';
const conductor = new Conductor({
apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted
});
const journalEntry = await conductor.qbd.journalEntries.create({
transactionDate: '2024-10-01',
conductorEndUserId: 'end_usr_1234567abcdefg',
});
console.log(journalEntry.id);import os
from datetime import date
from conductor import Conductor
conductor = Conductor(
api_key=os.environ.get("CONDUCTOR_SECRET_KEY"), # This is the default and can be omitted
)
journal_entry = conductor.qbd.journal_entries.create(
transaction_date=date.fromisoformat("2024-10-01"),
conductor_end_user_id="end_usr_1234567abcdefg",
)
print(journal_entry.id)curl --request POST \
--url https://api.conductor.is/v1/quickbooks-desktop/journal-entries \
--header 'Authorization: Bearer <token>' \
--header 'Conductor-End-User-Id: <conductor-end-user-id>' \
--header 'Content-Type: application/json' \
--data '
{
"transactionDate": "2024-10-01",
"refNumber": "JE-1234",
"isAdjustment": false,
"isHomeCurrencyAdjustment": false,
"areAmountsEnteredInHomeCurrency": false,
"currencyId": "80000001-1234567890",
"exchangeRate": 1.2345,
"externalId": "12345678-abcd-1234-abcd-1234567890ab",
"debitLines": [
{
"accountId": "80000001-1234567890",
"amount": "1000.00",
"memo": "Monthly utility bill settlement",
"entityId": "80000001-1234567890",
"classId": "80000001-1234567890",
"salesTaxItemId": "80000001-1234567890",
"billingStatus": "billable"
}
],
"creditLines": [
{
"accountId": "80000001-1234567890",
"amount": "1000.00",
"memo": "Allocated funds for office lease payment",
"entityId": "80000001-1234567890",
"classId": "80000001-1234567890",
"salesTaxItemId": "80000001-1234567890",
"billingStatus": "billable"
}
]
}
'<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.conductor.is/v1/quickbooks-desktop/journal-entries",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'transactionDate' => '2024-10-01',
'refNumber' => 'JE-1234',
'isAdjustment' => false,
'isHomeCurrencyAdjustment' => false,
'areAmountsEnteredInHomeCurrency' => false,
'currencyId' => '80000001-1234567890',
'exchangeRate' => 1.2345,
'externalId' => '12345678-abcd-1234-abcd-1234567890ab',
'debitLines' => [
[
'accountId' => '80000001-1234567890',
'amount' => '1000.00',
'memo' => 'Monthly utility bill settlement',
'entityId' => '80000001-1234567890',
'classId' => '80000001-1234567890',
'salesTaxItemId' => '80000001-1234567890',
'billingStatus' => 'billable'
]
],
'creditLines' => [
[
'accountId' => '80000001-1234567890',
'amount' => '1000.00',
'memo' => 'Allocated funds for office lease payment',
'entityId' => '80000001-1234567890',
'classId' => '80000001-1234567890',
'salesTaxItemId' => '80000001-1234567890',
'billingStatus' => 'billable'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Conductor-End-User-Id: <conductor-end-user-id>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.conductor.is/v1/quickbooks-desktop/journal-entries"
payload := strings.NewReader("{\n \"transactionDate\": \"2024-10-01\",\n \"refNumber\": \"JE-1234\",\n \"isAdjustment\": false,\n \"isHomeCurrencyAdjustment\": false,\n \"areAmountsEnteredInHomeCurrency\": false,\n \"currencyId\": \"80000001-1234567890\",\n \"exchangeRate\": 1.2345,\n \"externalId\": \"12345678-abcd-1234-abcd-1234567890ab\",\n \"debitLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Monthly utility bill settlement\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ],\n \"creditLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Allocated funds for office lease payment\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Conductor-End-User-Id", "<conductor-end-user-id>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.conductor.is/v1/quickbooks-desktop/journal-entries")
.header("Conductor-End-User-Id", "<conductor-end-user-id>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"transactionDate\": \"2024-10-01\",\n \"refNumber\": \"JE-1234\",\n \"isAdjustment\": false,\n \"isHomeCurrencyAdjustment\": false,\n \"areAmountsEnteredInHomeCurrency\": false,\n \"currencyId\": \"80000001-1234567890\",\n \"exchangeRate\": 1.2345,\n \"externalId\": \"12345678-abcd-1234-abcd-1234567890ab\",\n \"debitLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Monthly utility bill settlement\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ],\n \"creditLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Allocated funds for office lease payment\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.conductor.is/v1/quickbooks-desktop/journal-entries")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Conductor-End-User-Id"] = '<conductor-end-user-id>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"transactionDate\": \"2024-10-01\",\n \"refNumber\": \"JE-1234\",\n \"isAdjustment\": false,\n \"isHomeCurrencyAdjustment\": false,\n \"areAmountsEnteredInHomeCurrency\": false,\n \"currencyId\": \"80000001-1234567890\",\n \"exchangeRate\": 1.2345,\n \"externalId\": \"12345678-abcd-1234-abcd-1234567890ab\",\n \"debitLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Monthly utility bill settlement\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ],\n \"creditLines\": [\n {\n \"accountId\": \"80000001-1234567890\",\n \"amount\": \"1000.00\",\n \"memo\": \"Allocated funds for office lease payment\",\n \"entityId\": \"80000001-1234567890\",\n \"classId\": \"80000001-1234567890\",\n \"salesTaxItemId\": \"80000001-1234567890\",\n \"billingStatus\": \"billable\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"id": "123ABC-1234567890",
"objectType": "qbd_journal_entry",
"createdAt": "2025-01-01T12:34:56.000Z",
"updatedAt": "2025-02-01T12:34:56.000Z",
"revisionNumber": "1721172183",
"transactionDate": "2024-10-01",
"refNumber": "JE-1234",
"isAdjustment": false,
"isHomeCurrencyAdjustment": false,
"areAmountsEnteredInHomeCurrency": false,
"currency": {
"id": "80000001-1234567890",
"fullName": "USD"
},
"exchangeRate": 1.2345,
"externalId": "12345678-abcd-1234-abcd-1234567890ab",
"debitLines": [
{
"id": "456DEF-1234567890",
"objectType": "qbd_journal_debit_line",
"account": {
"id": "80000001-1234567890",
"fullName": "Checking"
},
"amount": "1000.00",
"memo": "Monthly utility bill settlement",
"entity": {
"id": "80000001-1234567890",
"fullName": "Acme Corporation"
},
"class": {
"id": "80000001-1234567890",
"fullName": "Facilities & Utilities"
},
"salesTaxItem": {
"id": "80000001-1234567890",
"fullName": "State Sales Tax"
},
"billingStatus": "billable"
}
],
"creditLines": [
{
"id": "456DEF-1234567890",
"objectType": "qbd_journal_credit_line",
"account": {
"id": "80000001-1234567890",
"fullName": "Accounts-Payable"
},
"amount": "1000.00",
"memo": "Allocated funds for office lease payment",
"entity": {
"id": "80000001-1234567890",
"fullName": "Acme Corporation"
},
"class": {
"id": "80000001-1234567890",
"fullName": "Administrative"
},
"salesTaxItem": {
"id": "80000001-1234567890",
"fullName": "State Sales Tax"
},
"billingStatus": "billable"
}
],
"customFields": [
{
"ownerId": "0",
"name": "Customer Rating",
"type": "string_1024_type",
"value": "Premium"
}
]
}Authorizations
Headers
Body
The case-sensitive user-defined reference number for this journal entry, which can be used to identify the transaction in QuickBooks. This value is not required to be unique and can be arbitrarily changed by the QuickBooks user. When left blank in this create request, this field will be left blank in QuickBooks (i.e., it does not auto-increment).
Maximum length: 11 characters.
11"JE-1234"
A globally unique identifier (GUID) you, the developer, can provide for tracking this object in your external system. This field is immutable and can only be set during object creation.
IMPORTANT: This field must be formatted as a valid GUID; otherwise, QuickBooks will return an error.
"12345678-abcd-1234-abcd-1234567890ab"
Response
Returns the newly created journal entry.
The current QuickBooks-assigned revision number of this journal entry object, which changes each time the object is modified. When updating this object, you must provide the most recent revisionNumber to ensure you're working with the latest data; otherwise, the update will return an error.
"1721172183"

